//
//  FLTARMODWidgetFactory.swift
//  flutter_armod_widget
//
//  Created by PhantomsXR on 23/08/2021.
//

import Foundation

class FLTARMODWidgetFactory: NSObject, FlutterPlatformViewFactory {
    private weak var registrar: FlutterPluginRegistrar?

    init(registrar: NSObjectProtocol & FlutterPluginRegistrar) {
        super.init()
        self.registrar = registrar
    }

    func createArgsCodec() -> (NSObjectProtocol & FlutterMessageCodec) {
        return FlutterStandardMessageCodec.sharedInstance()
    }
    
    func create(withFrame frame: CGRect, viewIdentifier viewId: Int64, arguments args: Any?) -> FlutterPlatformView {
        let controller = FLTARMODWidgetController(
            frame: frame,
            viewIdentifier: viewId,
            arguments: args,
            registrar: registrar as! FlutterPluginRegistrar)
        return controller
    }
}
