part of flutter_armod_widget;

class ARMODEvent<T1> {
  ///The id of the armod this event is accociated to.
  final int id;

  ///The value wrapped by this event
  final T1 value1;

  ARMODEvent(this.id, this.value1);
}

class deviceNotSupport extends ARMODEvent<void> {
  deviceNotSupport(int id, void value1) : super(id, value1);
}

class removeLoadingOverlay extends ARMODEvent<void> {
  removeLoadingOverlay(int id, void value1) : super(id, value1);
}

class addLoadingOverlay extends ARMODEvent<void> {
  addLoadingOverlay(int id, void value1) : super(id, value1);
}

class updateLoadingProgress extends ARMODEvent<dynamic> {
  updateLoadingProgress(int id, dynamic value1) : super(id, value1);
}

class throwException extends ARMODEvent<dynamic> {
  throwException(int id, dynamic value1) : super(id, value1);
}

class needInstallARCoreService extends ARMODEvent<void> {
  needInstallARCoreService(int id, void value1) : super(id, value1);
}

class sdkInitialized extends ARMODEvent<void> {
  sdkInitialized(int id, void value1) : super(id, value1);
}

class openBuiltInBrowser extends ARMODEvent<String?> {
  openBuiltInBrowser(int id, String? value1) : super(id, value1);
}

class recognitionStart extends ARMODEvent<void> {
  recognitionStart(int id, void value1) : super(id, value1);
}

class recognitionComplete extends ARMODEvent<void> {
  recognitionComplete(int id, void value1) : super(id, value1);
}

class tryAcquireInformation extends ARMODEvent<dynamic> {
  Function(String _data) callback;
  tryAcquireInformation(int id, dynamic value1,this.callback) : super(id, value1);
}

class packageSizeMoreThanPresetSize extends ARMODEvent<dynamic> {
  packageSizeMoreThanPresetSize(int id, dynamic value1) : super(id, value1);
}

class onARMODExit extends ARMODEvent<void> {
  onARMODExit(int id, void value1) : super(id, value1);
}

class onARMODLaunch extends ARMODEvent<void> {
  onARMODLaunch(int id, void value1) : super(id, value1);
}
